DLBitStringParser (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.asn1

## Class DLBitStringParser

- java.lang.Object
- - org.bouncycastle.asn1.DLBitStringParser

- All Implemented Interfaces:
    ASN1BitStringParser, ASN1Encodable, InMemoryRepresentable

      public class DLBitStringParser
      extends java.lang.Object
      implements ASN1BitStringParser

  Parser for a DL encoded BIT STRING.

- - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.io.InputStream` | `getBitStream()` Return an InputStream representing the contents of the BIT STRING.
    `ASN1Primitive` | `getLoadedObject()` Get the in-memory representation of the ASN.1 object.
    `java.io.InputStream` | `getOctetStream()` Return an InputStream representing the contents of the BIT STRING, where the content is expected to be octet-aligned (this will be automatically checked during parsing).
    `int` | `getPadBits()` Return the number of pad bits, if any, in the final byte, if any, read from `ASN1BitStringParser.getBitStream()`.
    `ASN1Primitive` | `toASN1Primitive()` Return an object, possibly constructed, of ASN.1 primitives

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### getBitStream

          public java.io.InputStream getBitStream()
                                           throws java.io.IOException

      Description copied from interface: `ASN1BitStringParser`
      Return an InputStream representing the contents of the BIT STRING. The final byte, if any, may include pad bits. See `ASN1BitStringParser.getPadBits()`.
      Specified by:
        `getBitStream` in interface `ASN1BitStringParser`
      Returns:
        an InputStream with its source as the BIT STRING content.
      Throws:
        `java.io.IOException`

    - #### getOctetStream

          public java.io.InputStream getOctetStream()
                                             throws java.io.IOException

      Description copied from interface: `ASN1BitStringParser`
      Return an InputStream representing the contents of the BIT STRING, where the content is expected to be octet-aligned (this will be automatically checked during parsing).
      Specified by:
        `getOctetStream` in interface `ASN1BitStringParser`
      Returns:
        an InputStream with its source as the BIT STRING content.
      Throws:
        `java.io.IOException`

    - #### getPadBits

          public int getPadBits()

      Description copied from interface: `ASN1BitStringParser`
      Return the number of pad bits, if any, in the final byte, if any, read from `ASN1BitStringParser.getBitStream()`. This number is in the range zero to seven. That number of the least significant bits of the final byte, if any, are not part of the contents and should be ignored. NOTE: Must be called AFTER the stream has been fully processed. (Does not need to be called if `ASN1BitStringParser.getOctetStream()` was used instead of `ASN1BitStringParser.getBitStream()`).
      Specified by:
        `getPadBits` in interface `ASN1BitStringParser`
      Returns:
        the number of pad bits. In the range zero to seven.

    - #### getLoadedObject

          public ASN1Primitive getLoadedObject()
                                        throws java.io.IOException

      Description copied from interface: `InMemoryRepresentable`
      Get the in-memory representation of the ASN.1 object.
      Specified by:
        `getLoadedObject` in interface `InMemoryRepresentable`
      Returns:
        an ASN1Primitive representing the loaded object.
      Throws:
        `java.io.IOException` - for bad input data.

    - #### toASN1Primitive

          public ASN1Primitive toASN1Primitive()

      Description copied from interface: `ASN1Encodable`
      Return an object, possibly constructed, of ASN.1 primitives
      Specified by:
        `toASN1Primitive` in interface `ASN1Encodable`
      Returns:
        an ASN.1 primitive.